import { Test, TestingModule } from '@nestjs/testing';
import { UserController } from './user.controller';
import { UserService } from './user.service';

describe('UserController', () => {
  let controller: UserController;

  const mockUsers = [
    {
      id: `${Date.now()}`,
      name: 'User 1',
      email: 'email1@email.com',
      createdAt: Date.now(),
      updatedAt: Date.now(),
    },
  ];

  const mockUserService = {
    findAll: jest.fn(() => mockUsers),
  };

  beforeEach(async () => {
    const module: TestingModule = await Test.createTestingModule({
      controllers: [UserController],
      providers: [UserService],
    })
      .overrideProvider(UserService)
      .useValue(mockUserService)
      .compile();

    controller = module.get<UserController>(UserController);
  });

  it('should be defined', () => {
    expect(controller).toBeDefined();
  });

  it('should return all users', () => {
    expect(controller.findAll()).toEqual(mockUsers);
  });
});
