import {
  Column,
  Model,
  Table,
  CreatedAt,
  UpdatedAt,
  PrimaryKey,
  DataType,
  NotEmpty,
  Default,
  HasMany,
} from 'sequelize-typescript';
import { Rank } from '../rank/rank.model';

@Table({
  timestamps: true,
})
export class User extends Model {
  @PrimaryKey
  @Default(DataType.UUIDV4)
  @Column(DataType.STRING)
  id: string;

  @NotEmpty
  @Column
  name: string;

  @NotEmpty
  @Column
  email: string;

  @NotEmpty
  @Column
  password: string;

  @CreatedAt
  @Column
  createdAt: Date;

  @UpdatedAt
  @Column
  updatedAt: Date;

  @HasMany(() => Rank)
  ranks: Rank[];
}
